<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import DefaultTemplate from '~/components/solutions/templates/default-template.vue';
import IndustryTemplate from '~/components/solutions/templates/industry-template.vue';
import FeaturesTemplate from '~/components/features/templates/features-template.vue';

import { getPageMetadata } from '~/common/meta';
import { TEMPLATES } from '~/common/constants';

export default Vue.extend({
  components: {
    DefaultTemplate,
    IndustryTemplate,
    FeaturesTemplate,
  },
  async asyncData({ params, error, $solutionsService }: any) {
    try {
      const isIndexSlug = !params.solutions;
      const solutions = await $solutionsService.getContent(
        `solutions${params.solutions ? `/${params.solutions}` : ''}`,
        isIndexSlug,
      );

      return { solutions };
    } catch (e) {
      console.error(e);
      error({ statusCode: 404 });
      return {};
    }
  },
  data() {
    return {
      TEMPLATES,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).solutions,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <industry-template
    v-if="solutions?.template === TEMPLATES.Industry"
    :solutions="solutions"
  />
  <features-template
    v-else-if="solutions?.template === TEMPLATES.Feature"
    :page="solutions"
  />
  <solutions-templates-industry-template-alt
    v-else-if="solutions?.template === TEMPLATES.IndustryAlternative"
    :solutions="solutions"
  />
  <default-template v-else :solutions="solutions" />
</template>
